function LocationManager( initialLocation) {

	this.lastKnownLocation = initialLocation;


	this.setPSType = function (psType) {
		this.psType = psType;
		if (psType == 'external') {
			// do nothing
		} else if (psType == 'browser') {
			if (navigator.geolocation) {
			var watchId = navigator.geolocation.watchPosition(this.successCallback,this.errorCallback,{enableHighAccuracy:true, timeout:60000, maximumAge:0});
			} else {
				console.log( "Geolocation is not supported by this browser.");
			}

		} else if (psType == 'ips') {

			this.ips = new IPS(this);

		} else if (psType == 'test') {

			this.registerTestPositioning();

		}

	}
	
	
	
	
	this.successCallback = function (position) {
	var s = "Latitude: " + position.coords.latitude +
    "<br>Longitude: " + position.coords.longitude;
	//console.log(s);
	locationManager.handleLocationFound(ol.proj.fromLonLat([position.coords.longitude,position.coords.latitude]));
	if(!this.initialLocationSet){
		map.getView().setCenter(ol.proj.fromLonLat([position.coords.longitude,position.coords.latitude]));
		//map.getView().setZoom(18);
		this.initialLocationSet=true
	}
	}
	this.errorCallback = function (e) {
	//alert(e);
	
	}
	
	this.registerTestPositioning = function () {
		map.on('click', function (evt) {
			var feature = map.forEachFeatureAtPixel(evt.pixel, function (feature, layer) {
 				return feature;
 			});

 		 		if (!feature || (feature.get("type") != "marker-with-popup" && feature.get("type") != "temp-marker-with-popup")) {

		   locationManager.handleLocationFound(evt.coordinate);

 		}
			
		});

	}

	this.getLastKnownLocation = function () {
		return this.lastKnownLocation;

	}
	
	this.handleLocationFound = function (newLocation,beaconData) {
		//console.log(JSON.stringify(newLocation))
		this.lastKnownLocation = newLocation;
		userLocationDisplay.updateUserLocationDisplay(newLocation);


	}
	
	this.handleLocationError = function () {}

	this.handleLocationWarning = function () {}

}