
function UserLocationDisplay(vectorLocation){
	
this.displayUserLocation = true;
this.acuracy =0.1;
this.vectorLocation=vectorLocation;

this.iconStyle = new ol.style.Icon(/** @type {olx.style.IconOptions} */
		({
			anchor : [0.5, 0.5],
			anchorXUnits : 'fraction',
			anchorYUnits : 'fraction',
			scale: 0.5,
			src : './ulo_arrow.png'

		}));

this.userLocationCircleStyle = new ol.style.Style({
		stroke : new ol.style.Stroke({
			color : 'rgba(217, 0,0, 0)',
			width : 1
		}),
		fill : new ol.style.Fill({
			color : 'rgba(217, 0, 0, 0.1)'
		})
	});


this.resetUserIconRotation = function() {
	if (this.userLocationIconFeature) {
		this.userLocationIconFeature.getStyle().getImage().setRotation(0);
		this.userLocationIconFeature.changed();
		this.vectorLocation.getSource().changed();
	}

}

this.updateUserIconRotation = function(rotation) {
	if (this.userLocationIconFeature) {

		this.userLocationIconFeature.getStyle().getImage().setRotation(rotation);
		this.userLocationIconFeature.changed();
		this.vectorLocation.getSource().changed();
	}

}


this.setDisplayUserLocation = function(display) {
	//console.log("setDisplayUserLocation: "+ display)
	this.displayUserLocation = display;
	if (!this.displayUserLocation) {
		if (this.vectorLocation.getSource().getFeatureById("userLocationIconFeature")) {
			this.vectorLocation.getSource().removeFeature(this.userLocationIconFeature);
			this.userLocationIconFeature =undefined
		}
		if (this.vectorLocation.getSource().getFeatureById("userLocationCircleFeature")) {
			this.vectorLocation.getSource().removeFeature(this.userLocationCircleFeature);
			this.userLocationCircleFeature=undefined
		}
	}
}

this.createUserLocationIcon = function() {
	var userLocationIconFeature = new ol.Feature({
			id : 'userLocationIconFeature',
			type : 'icon',
			geometry : new ol.geom.Point([0, 0]),
			name : 'icon marker'
		});
	userLocationIconFeature.setId('userLocationIconFeature');
	//var userLocationIconStyle = new ol.style.Style({
	//		image : this.iconStyle
	//	});
		var	userLocationIconStyle = new ol.style.Style({
						image : new ol.style.Circle({
							radius : 5,
							fill : new ol.style.Fill({
								color : 'rgba(255, 0, 255, 1)'
							}),
							stroke : new ol.style.Stroke({
								color : 'rgba(255, 0, 255, 1)',
								width : 2
							})
						})
					});
	userLocationIconFeature.setStyle(userLocationIconStyle);
	return userLocationIconFeature;
}

this.createUserLocationCircle = function() {
	var userLocationCircle = new ol.geom.Circle([0, 0], this.acuracy);
	var userLocationCircleFeature =
		new ol.Feature({
			id : 'userLocationCircleFeature',
			type : 'icon',
			geometry : userLocationCircle,
			name : 'icon circle'
		});
	userLocationCircleFeature.setId('userLocationCircleFeature');
	userLocationCircleFeature.setStyle(this.userLocationCircleStyle);
	return userLocationCircleFeature;
}

this.updateUserLocationDisplay = function(newLocation) {
	console.log("setDisplayUserLocation: "+ newLocation)
	//if(!ol.extent.containsCoordinate(viewableBounds, newLocation)){
	//		return;
	//	}
		//	console.log("setDisplayUserLocation: "+ newLocation)
	if (this.displayUserLocation) {
		this.userLocationIconFeature = this.vectorLocation.getSource().getFeatureById("userLocationIconFeature");
		if (!this.userLocationIconFeature) {
			this.userLocationIconFeature = this.createUserLocationIcon();
			this.vectorLocation.getSource().addFeature(this.userLocationIconFeature);
		}
		this.userLocationIconFeature.getGeometry().setCoordinates(newLocation);
		this.userLocationCircleFeature = this.vectorLocation.getSource().getFeatureById("userLocationCircleFeature")
			if (!this.userLocationCircleFeature) {
				this.userLocationCircleFeature = this.createUserLocationCircle()
					this.vectorLocation.getSource().addFeature(this.userLocationCircleFeature);
			}
			this.userLocationCircleFeature.getGeometry().setCenter(newLocation);
			this.vectorLocation.getSource().changed();
	}
}
}