var bindLinkEditor;
var select_interaction, draw_interaction, modify_interaction;
var $geom_type;
var $interaction_type;
var $draw_controls;
var vector_layer;
var vectorSource;



function initNavEditor() {

	

	vectorSource = new ol.source.Vector();

	vector_layer = new ol.layer.Vector({
			name : 'nav',
			source : vectorSource,
			style : backboneStyle()
	
		});

		
		
	map.addLayer(vector_layer);


	bindLinkEditor = new BindLinkEditor(map, vector_layer);
	
	var backboneJSON = serverConnector.getBackboneJSON();
	if (backboneJSON)
		loadNavLayer(backboneJSON,vectorSource);
	
	

	$geom_type = $('#geom_type');
	$interaction_type = $('[name="interaction_type"]');
	$draw_controls = $('[id="draw_controls"]');

	$geom_type.on('change', function (e) {
		updateForDraw();
	});

	initForDraw();

	// rebuild interaction when changed
	$interaction_type.on('click', function (e) {
		// add new interaction
		if (this.value === 'draw') {
			initForDraw();
		} else if (this.value === 'modify') {
			initForModify();
		} else if (this.value === 'link') {
			initForLink();
		}
	});
	
  

//	map.on('pointermove', function (evt) {
		
	//});

	//map.on('click', function (evt) {

//	});
	
}

function initForDraw() {
	////console.log("initForDraw");
	resetPropertiesEditStyle();
	$(document).off('keyup');
	$draw_controls.show();
	map.removeInteraction(select_interaction);
	map.removeInteraction(modify_interaction);
	map.removeInteraction(draw_interaction);

	addSelectInteraction();
	addDrawInteraction();
	addConnectionMode = false;
	bindLinkEditor.unregisterCreateLinkEvents();
	resetSelectedFeaturePropertiesDisplay();
}
function updateForDraw() {
	////console.log("updateForDraw");
	resetPropertiesEditStyle();
	$(document).off('keyup');
	map.removeInteraction(draw_interaction);
	addDrawInteraction();
	addConnectionMode = false;
	resetSelectedFeaturePropertiesDisplay();
}

function initForModify() {
	$(document).off('keyup');
	$draw_controls.hide();
	map.removeInteraction(select_interaction);
	map.removeInteraction(draw_interaction);
	map.removeInteraction(modify_interaction);
	addSelectInteraction();
	addModifyInteraction();
	addConnectionMode = false;

	resetSelectedFeaturePropertiesDisplay();
	bindLinkEditor.unregisterCreateLinkEvents();

}

function initForLink() {
	$(document).off('keyup');
	$draw_controls.hide();

	map.removeInteraction(select_interaction);
	map.removeInteraction(modify_interaction);
	map.removeInteraction(draw_interaction);
	addConnectionMode = true;
	resetSelectedFeaturePropertiesDisplay();
	bindLinkEditor.registerCreateLinkEvents();
}

// build up modify interaction
// needs a select and a modify interaction working together


function addSelectInteraction() {

	// remove draw interaction
	// create select interaction
	select_interaction = new ol.interaction.Select({
			// make sure only the desired layer can be selected
			layers : function (vector_layer) {
				return vector_layer.get('name') === 'nav';
			},
			filter : function (feature, layer) {
				//console.log("filter: " + feature.get("type"));
					return feature;
			
			}
		});
	select_interaction.on('select', select);
	map.addInteraction(select_interaction);
	//var selected_features = select_interaction.getFeatures();

}


function deleteItem(selected_feature, select_interaction) {
	var selected_features = select_interaction.getFeatures();

	if (selected_features.getLength() > 0) {
		//selected_feature = selected_features.item(selected_features.getLength() - 1);
		console.log("remove started "+selected_feature.getId() );
		bindLinkEditor.removeSelectedFeature(selected_feature);
		selected_features.remove(selected_feature);
		resetSelectedFeaturePropertiesDisplay();

	}
}

function addModifyInteraction() {

	var selected_features = select_interaction.getFeatures();

	// create the modify interaction
	modify_interaction = new ol.interaction.Modify({

			features : selected_features,
			// delete vertices by pressing the SHIFT key
			deleteCondition : function (event) {
				return ol.events.condition.shiftKeyOnly(event) &&
				ol.events.condition.singleClick(event);
			}
		});
	// add it to the map
	map.addInteraction(modify_interaction);
	modify_interaction.on('modifystart', modifystart);
	modify_interaction.on('modifyend', modifyend, null);
	//  modify_interaction.on('propertychange', propertychange,null);
	//  modify_interaction.on('change', change,null);

}

function select(evt) {
	////console.log("select_interaction: select=" + evt.selected);
	resetPropertiesEditStyle();
	var feature = evt.selected[0];
	if (feature) {
			selectNavFeatureForPropertiesEdit(evt.selected[0]);
	}

}

function modifyend(evt) {
	// //console.log("modifyend");
	updateSelectedFeatureCoordinates();
	bindLinkEditor.updateFeatureOnModifyEnd(evt);

}

function modifystart(evt) {}

// creates a draw interaction
function addDrawInteraction() {
	// remove other interactions
	////console.log("addDrawInteraction");

	var value = $geom_type.val();
	if (value !== 'None') {
		var geometryFunction,
		maxPoints;
		if (value === 'Square') {
			value = 'Circle';
			geometryFunction = ol.interaction.Draw.createRegularPolygon(4);
		} else if (value === 'Box') {
			value = 'LineString';
			maxPoints = 2;
			geometryFunction = function (coordinates, geometry) {
				if (!geometry) {
					geometry = new ol.geom.Polygon(null);
				}
				var start = coordinates[0];
				var end = coordinates[1];
				geometry.setCoordinates([
						[start, [start[0], end[1]], end, [end[0], start[1]], start]
					]);
				return geometry;
			};
		}
		draw_interaction = new ol.interaction.Draw({
				source : vector_layer.getSource(),
				type : /** @type {ol.geom.GeometryType} */
				(value),
				geometryFunction : geometryFunction,
				maxPoints : maxPoints
			});

	}

	// add it to the map
	map.addInteraction(draw_interaction);

	draw_interaction.on('drawend', function (event) {
		
		// create a unique id
		
		var id = uid("N");
		event.feature.setId(id);

		event.feature.set('gType', $geom_type.val());
		
		var value = $geom_type.val();


		if (value == "Point") {
			event.feature.set('type', "nav-node");
				//event.feature.setStyle(navPolygonStyle);
		}
		if (value == "Polygon") {
			event.feature.set('type', "nav-node-polygon");
				//event.feature.setStyle(navPolygonStyle);
		}

		if (value == "Square") {
			event.feature.set('type', "nav-node-polygon");
			//	event.feature.setStyle(navPolygonStyle);
		}

		if (value == "Box") {
			event.feature.set('type', "nav-node-polygon");
			//	event.feature.setStyle(navPolygonStyle);
		}
		if (value == "Circle") {
			event.feature.set('type', "nav-node-polygon");
			//	event.feature.setStyle(navPolygonStyle);
		}

		if ($geom_type.val() == "Point") {

			polygon = isInsidePolygon(event.feature.getGeometry().getCoordinates());

			if (polygon) {
				createNewNavPointInPolygon(event.feature, polygon);
			}
			createNewNavPoint(event.feature);
		} 
		


	});

}

function createNewNavPoint(mainPointFeature) {

	//mainPointFeature.setStyle(navNodeStyle);
	//	moveControlFeature = createMoveControlFeature(mainPointFeature);
	//vector_layer.getSource().addFeature(moveControlFeature);

}

function createNewNavPointInPolygon(mainPointFeature, polygon) {
	closestPoint = polygon.getGeometry().getClosestPoint(mainPointFeature.getGeometry().getCoordinates());
	mainPointFeature.getGeometry().setCoordinates(closestPoint);
//	mainPointFeature.setStyle(navNodeStyle);
	mainPointFeature['polygon'] = polygon;
	if (!polygon['linkPoints'])
		polygon['linkPoints'] = [];
	polygon['linkPoints'].push(mainPointFeature);

	//	moveControlFeature = createMoveControlFeature(mainPointFeature);
	//vector_layer.getSource().addFeature(moveControlFeature);


}


function isInsidePolygon(coord) {
	var pixel = map.getPixelFromCoordinate(coord);
	////console.log('pixel' + pixel);
	var feature = map.forEachFeatureAtPixel(pixel,
			function (feature) {
			if (feature.get("type") == "nav-node-polygon")
				return feature;
			else
				return null;
		});

	return feature;

}

function onPointerDown(evt) {
	////console.log('map:onPointerDown');

}
function onPointerUp(evt) {
	////console.log('map:onPointerUp');

}


var savedData;
var dataToSave = {};
function saveData() {
	var points = {};
	var polygons = {};
	var links = {};

	var features = vector_layer.getSource().getFeatures();
	for (var i = 0; i < features.length; i++) {
		var feature = features[i];
		if (feature.get("type") == "nav-node") {
			//console.log('found point: ' + feature.getId());
			var pointData = {};
			var id = feature.getId();
			var pointLinksData = {};
			var polygon = feature['polygon'];
			if (polygon) {
				//	console.log('polygon.getId()' +polygon.getId());
				pointData['polygon'] = polygon.getId();
			}
			pointData['type'] = feature.get('type');
			pointData['label'] = feature.get('name');
			pointData['coord'] = feature.getGeometry().getCoordinates();
			// get links
			if (feature['links']) {
				for (var l = 0; l < feature['links'].length; l++) {
					var link = feature['links'][l];
					var destinationPoint;
					if (link['startPoint'] === feature) {
						destinationPoint = link['endPoint'];
					} else {
						destinationPoint = link['startPoint'];

					}
					pointLinksData[destinationPoint.getId()] = link.getId();
				}
				pointData['links'] = pointLinksData;
			}

			// set data
			points[id] = pointData;

		}
		if (feature.get("type") == "nav-node-bbl") {
			//console.log('found point: ' + feature.getId());
			var pointData = {};
			var hostLinkData = {};

			var id = feature.getId();
			var pointLinksData = {};
			var polygon = feature['polygon'];
			if (polygon) {
				pointData['polygon'] = polygon.getId();
			}

			pointData['type'] = feature.get('type');
			pointData['label'] = feature.get('name');
			pointData['coord'] = feature.getGeometry().getCoordinates();

			// get links
			if (feature['links']) {
				for (var l = 0; l < feature['links'].length; l++) {
					var link = feature['links'][l];
					var destinationPoint;
					if (link['startPoint'] === feature) {
						destinationPoint = link['endPoint'];
					} else {
						destinationPoint = link['startPoint'];

					}
					pointLinksData[destinationPoint.getId()] = link.getId();
				}
				pointData['links'] = pointLinksData;
			}

			var hostLink = feature['hostLink'];

			hostLinkData['id'] = hostLink.getId();
			hostLinkData['startPoint'] = hostLink['startPoint'].getId();
			hostLinkData['endPoint'] = hostLink['endPoint'].getId();

				pointData['hostLink'] = hostLinkData;
			// set data
			points[id] = pointData;

		}
		if (feature.get("type") == "nav-link") {
			//console.log('found point: ' + feature.getId());
			var linkData = {};
			var navNodesBBLData = {};
			var id = feature.getId();
			linkData['type'] = feature.get('type');
			linkData['label'] = feature.get('name');
			linkData['coord'] = feature.getGeometry().getCoordinates();
			linkData['startPoint'] = feature['startPoint'].getId();
			linkData['endPoint'] = feature['endPoint'].getId();
			var ex_path_types = feature.get('ex_path_types');
			if(ex_path_types) {
				linkData['ex_path_types'] = ex_path_types;
			}

			// get links
			if (feature['navNodesBBL']) {
				for (var l = 0; l < feature['navNodesBBL'].length; l++) {
					var navNodeBBL = feature['navNodesBBL'][l];
					navNodesBBLData[navNodeBBL.getId()] = navNodeBBL.getId();
				}

				linkData['navNodesBBL'] = navNodesBBLData;
			}

			// set data
			links[id] = linkData;

		}
		if (feature.get("type") == "nav-node-polygon") {
			//console.log('found polygon: ' + feature.getId());
			var polygonData = {};
			var id = feature.getId();
			var polygonLinkPointsData = {};
			polygonData['type'] = feature.get('type');
			polygonData['label'] = feature.get('name');
			polygonData['coord'] = feature.getGeometry().getCoordinates();
			polygonData['dt'] = feature.get('dt');
			
			// get points
			if (feature['linkPoints']) {
				for (var l = 0; l < feature['linkPoints'].length; l++) {
					var linkPoint = feature['linkPoints'][l];
					polygonLinkPointsData[linkPoint.getId()] = linkPoint.getId();
				}
				polygonData['linkPoints'] = polygonLinkPointsData;
			}
			var ex_path_types = feature.get('ex_path_types');
			if(ex_path_types) {
				polygonData['ex_path_types'] = ex_path_types;
			}

			// set data
			polygons[id] = polygonData;
		}

	}
	dataToSave['points'] = points;
	dataToSave['polygons'] = polygons;
	dataToSave['links'] = links;
	var s = JSON.stringify(dataToSave);
	$('#data').val(s);
	savedData = s;
	serverConnector.saveData("backbone_json",s);
}

function loadData() {
	var s = $('#data').val();
	////console.log('load: '+s );
	removeAllFeatures();
	loadNavLayer(s,vectorSource);

}

function saveRoutingData() {
	savedRoutingData=$('#data').val();
	serverConnector.saveData("routing_json",savedRoutingData);

}





function removeAllFeatures() {
var features = vector_layer.getSource().getFeatures();
	for (var i = 0; i < features.length; i++) {
	     vectorSource.removeFeature(features[i])
	}

}
function downloadData() {
	if(savedData){
		download("backbone_json.js", 'localData_backbone_json = '  + savedData);
	}
}
function downloadRoutingData() {
	if(savedRoutingData){
		download("routing_json.js", 'localData_routingJSON = ' + savedRoutingData );
	}
}

 
function download(filename, text) {
	var element = document.createElement('a');
	element.setAttribute('href', 'data:text/javascript;charset=utf-8,' + encodeURIComponent(text));
	element.setAttribute('download', filename);

	element.style.display = 'none';
	document.body.appendChild(element);

	element.click();

	document.body.removeChild(element);
}


function selectNavFeatureForPropertiesEdit(feature) {

	if (feature) {
		selectedfeature = feature;

		$('#editData').show();

		var $selectedFeatureID = $('#selectedFeatureID');
		var $selectedFeatureCoord = $('#selectedFeatureCoord');
		var $labelData = $('#labelData');
		var $selectedFeatureDisableTransit = $('#selectedFeatureDisableTransit');


		$selectedFeatureID.val(selectedfeature.get("type") + ": " + selectedfeature.getId());

		$selectedFeatureCoord.val(JSON.stringify(selectedfeature.getGeometry().getCoordinates()));
		$labelData.val(selectedfeature.get('name'));
		
		if (feature.get("type") == "nav-node-polygon") {
		//	feature.setStyle(navNodeStyle);
			$('#selectedFeatureDisableTransitWrappers').show();
			if(selectedfeature.get('dt'))
				$selectedFeatureDisableTransit.prop('checked',true);
			else $selectedFeatureDisableTransit.prop('checked',false);
		} else {
			$('#selectedFeatureDisableTransitWrapper').hide();
		}
		

		
		if (feature.get("type") != "nav-node") {
		//	feature.setStyle(navNodeStyle);
			$('#path-types').show();
		} else {
			$('#path-types').hide();
		}
		
		var ex_path_types = selectedfeature.get('ex_path_types');
		$("input[name='path_types[]']").map(function(){
			if(ex_path_types && ex_path_types[$(this).val()]) {
				$(this).prop('checked',false);
			} else {
				$(this).prop('checked',true);
			}
		})
	
		
	}
}

function resetPropertiesEditStyle() {
	var features = vector_layer.getSource().getFeatures();
	for (var i = 0; i < features.length; i++) {
		var feature = features[i];
		if (feature.get("type") == "Point") {
		//	feature.setStyle(navNodeStyle);

		}
	}

	$('#editData').hide();
}

function unselectFeatureForPropertiesEdit(feature) {}

function updateSelectedFeatureCoordinates() {
	var $selectedFeatureCoord = $('#selectedFeatureCoord');
	$selectedFeatureCoord.val(JSON.stringify(selectedfeature.getGeometry().getCoordinates()));

}

function resetSelectedFeaturePropertiesDisplay() {
	//resetPropertiesEditStyle()
	//console.log("resetSelectedFeaturePropertiesDisplay");
	selectedfeature = null;
	$('#editData').hide();
}

var selectedfeature;

function saveLabelDataClicked() {
	var $selectedFeatureCoord = $('#selectedFeatureCoord');
	var $labelData = $('#labelData');
	var $selectedFeatureDisableTransit = $('#selectedFeatureDisableTransit');
	
	// var element = document.getElementById('labelData');
	selectedfeature.getGeometry().setCoordinates(JSON.parse($selectedFeatureCoord.val()));
	selectedfeature.set('name', $labelData.val());
	var dt= $selectedFeatureDisableTransit.is(':checked');
	//console.log("dt: " +dt);
	if(dt)
	selectedfeature.set('dt', true )
	else selectedfeature.set('dt', undefined );
	
	var ex_path_types ={};
	$("input[name='path_types[]']:not(:checked)").map(function(){
	      ex_path_types[$(this).val()]=$(this).val();
    })
	//console.log(ex_path_types);
	if(Object.keys(ex_path_types).length>0){
	  selectedfeature.set('ex_path_types', ex_path_types);
	  
	 // selectedfeature.getStyle().setStroke(pathStrokes[2]);
	}
	else {
	 selectedfeature.set('ex_path_types', undefined);
    //  selectedfeature.getStyle().setStroke(pathStrokes.none);
  
	}
	
  // console.log("saveLabelDataClicked");
	return false;
}
function deleteFeatureClicked() {
	deleteItem(selectedfeature, select_interaction);
}

var savedRoutingData;




function calculateRouts1(){
	var routsCalculator = new RoutsCalculator();
	var navDataString = savedData;
	if(!navDataString)
	navDataString = serverConnector.getBackboneJSON();
	routsCalculator.calculateRoutingTable(navDataString);
	var s = JSON.stringify(routsCalculator.routingTable);
	$('#data').val(s);
	savedRoutingData=s;
	serverConnector.saveData("routing",s);
}

function calculateRouts() {
	if (window.Worker) {
		var rc_worker = new Worker("./js/RoutsCalculator.js");

		var navDataString = savedData;
		if (!navDataString)
			navDataString = serverConnector.getBackboneJSON();
		//console.log('navDataString ' +navDataString);
		rc_worker.postMessage(["start", navDataString]);

		rc_worker.onmessage = function (e) {
			//console.log('Message received from worker: ' + e.data);
			$('#rc_progress').html(e.data[0]);
			if (e.data[0] == 'finished') {
				var routingTable = e.data[1];
				var s = JSON.stringify(routingTable);
				$('#data').val(s);
				savedRoutingData = s;
				serverConnector.saveData("routing_json", s);
			}
		};

	}

}



$('a[data-toggle="tab"]').on('shown.bs.tab', function (e) {
	//console.log('showing tab ' + e.target); // Active Tab
	//console.log('showing tab ' + e.relatedTarget); // Previous Tab
})

$(document).on('shown.bs.tab', 'a[data-toggle="tab"]', function (e) {
	//var activatedTab = e.target; // activated tab
	//console.log('showing tab ' + e.target); // Active Tab
})